// Moebius.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Moebius.h"
#include "MainFrm.h"

#include "MBDoc.h"
#include "MBView.h"
#include "MBGLView.h"
#include "ChildFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMoebiusApp

BEGIN_MESSAGE_MAP(CMoebiusApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()


// CMoebiusApp construction

CMoebiusApp::CMoebiusApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CMoebiusApp object

CMoebiusApp theApp;

// CMoebiusApp initialization

BOOL CMoebiusApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();

	CWinApp::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));
	LoadStdProfileSettings(4);  // Load standard INI file options (including MRU)
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(IDR_MoebiusTYPE,
		RUNTIME_CLASS(CMBDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CMBView));
	AddDocTemplate(pDocTemplate);
	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;
	// call DragAcceptFiles only if there's a suffix
	//  In an MDI app, this should occur immediately after setting m_pMainWnd
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	// The main window has been initialized, so show and update it
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	return TRUE;
}



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CMoebiusApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CMoebiusApp message handlers


BOOL CMoebiusApp::OnIdle(LONG lCount)
{
  BOOL NeedTime=CWinApp::OnIdle(lCount);
  int dcnt =0;
  POSITION pos = GetFirstDocTemplatePosition();
  while (pos != NULL)
  {
     CDocTemplate* pt = GetNextDocTemplate(pos);
     assert(pt);
     POSITION dpos = pt->GetFirstDocPosition();
     while (dpos != NULL)
     {
         dcnt++;
         CMBDoc *pd=(CMBDoc *)pt->GetNextDoc(dpos);
         POSITION vpos = pd->GetFirstViewPosition();
         while (vpos != NULL)
         {
						 CView *base=pd->GetNextView(vpos);
						 if(DYNAMIC_DOWNCAST(CMBView ,base) )
						 {	
							 //TRACE("Form View \n");
						 }
						 if(DYNAMIC_DOWNCAST(CMBGLView ,base) ){
							 //TRACE("Opengl View \n");
						   CMBGLView* pView = (CMBGLView*)base;
               pView->Invalidate();
             }
         }   
     }
  }   
  return dcnt;
}
